; This file is part of the source code for "Super Connard" V1
; Creative Commons BY-NC-SA 2013 - furrtek.org

Setup_bmode:
  di

  call   screen_off

  ld     a,%11100100            ;BG palette
  ldh    ($47),a

  ld     hl,(:tiles_alpha*$4000)+tiles_alpha
  ld     de,$8000
  call   loadtiles_auto

  ld     hl,(:tiles_trollface*$4000)+tiles_trollface
  ld     de,$8000+(96*16)
  call   loadtiles_auto
  
  call   clearbkg
  call   clearsprites
  
  ld     de,text_bmode
  ld     hl,$9800+(12*32)+4
  ld     b,32
  call   maptext

  ;map la trollface
  ld     a,96
  ld     de,$9846
  ld     hl,(:map_trollface*$4000)+map_trollface
  call   map

  xor    a
  ldh    ($42),a                ;Scroll Y
  ldh    ($43),a                ;Scroll X

  ld     a,%11111111            ;Palette BG, everything in white
  ldh    ($47),a

  ld     a,%10010001            ;Turn screen on, BG on, sprites OFF, window OFF, tiles at $8000
  ldh    ($40),a

  ld     a,%00010000            ;Vblank
  ldh    ($41),a
  ld     a,%00000001
  ldh    ($FF),a

  xor    a
  ld     (FADEIDX),a
  cpl
  ld     (BMODE),a

  ld     hl,VBL_HANDLER
  ld     de,VBL_bmode
  ld     (hl),e
  inc    hl
  ld     (hl),d

  ld     de,RLI_null
  call   load_RLI
  
  ei

  ret

VBL_bmode:
  call   fadefromwhite

  call   readinput
  and    $0F
  jr     z,+
  jr	 ++
+:
  ld     a,(VBLC)
  inc    a
  cp     $C0            ;~3 seconds
  jr     nz,+
++:
  ld     de,Setup_title
  call   Setup_exit_white
  ret
+:
  ld     (VBLC),a
  ret
