; This file is part of the source code for "Super Connard" V1
; Creative Commons BY-NC-SA 2013 - furrtek.org

fadeblack:
  .db %11111111,%11101010,%11100101,%11100100
fadewhite:
  .db %00000000,%01010100,%10100100,%11100100

;FADEIDX:15 to 0
fadetowhite:
  ld    a,(FADEIDX)
  ld    b,a
  srl   a
  srl   a
  ld    hl,fadewhite
  ld    d,0
  ld    e,a
  add   hl,de
  ld    a,(hl)
  ldh    ($47),a
  ld    a,b
  or    a
  ret   z
  ld    hl,FADEIDX
  dec   (hl)
  ret

;FADEIDX:15 to 0
fadetoblack:
  ld    a,(FADEIDX)
  ld    b,a
  srl   a
  srl   a
  ld    hl,fadeblack
  ld    d,0
  ld    e,a
  add   hl,de
  ld    a,(hl)
  ldh    ($47),a
  ld    a,b
  or    a
  ret   z
  ld    hl,FADEIDX
  dec   (hl)
  ret

;FADEIDX:0 to 15
fadefromwhite:
  ld    a,(FADEIDX)
  srl   a
  srl   a
  cp    4
  ret   z
  ld    hl,fadewhite
  ld    d,0
  ld    e,a
  add   hl,de
  ld    a,(hl)
  ldh    ($47),a
  ld    hl,FADEIDX
  inc   (hl)
  ret

;FADEIDX:0 to 15
fadefromblack:
  ld    a,(FADEIDX)
  srl   a
  srl   a
  cp    4
  ret   z
  ld    hl,fadeblack
  ld    d,0
  ld    e,a
  add   hl,de
  ld    a,(hl)
  ldh    ($47),a
  ld    hl,FADEIDX
  inc   (hl)
  ret

VBL_fadetowhite:
  ld     a,(RESETX)
  bit    0,a
  jr     z,+
  xor    a
  ldh    ($43),a                ;Scroll X
+:
  call   fadetowhite
  ld     a,(FADEIDX)
  or     a
  ret    nz
  ld     hl,TOSETUP
  ldi    a,(hl)
  ld     h,(hl)
  ld     l,a
  call   dojump
  ret
  
VBL_fadetoblack:
  ld     a,(RESETX)
  bit    0,a
  jr     z,+
  xor    a
  ldh    ($43),a                ;Scroll X
+:
  call   fadetoblack
  ld     a,(FADEIDX)
  or     a
  ret    nz
  ld     hl,TOSETUP
  ldi    a,(hl)
  ld     h,(hl)
  ld     l,a
  call   dojump
  ret

Setup_exit_white:
  ld     hl,TOSETUP
  ld     (hl),e
  inc    hl
  ld     (hl),d
  ld     hl,VBL_HANDLER
  ld     de,VBL_fadetowhite
  ld     (hl),e
  inc    hl
  ld     (hl),d
  ld     a,15
  ld     (FADEIDX),a
  ret

Setup_exit_black:
  ld     hl,TOSETUP
  ld     (hl),e
  inc    hl
  ld     (hl),d
  ld     hl,VBL_HANDLER
  ld     de,VBL_fadetoblack
  ld     (hl),e
  inc    hl
  ld     (hl),d
  ld     a,15
  ld     (FADEIDX),a
  ret
