; This file is part of the source code for "Super Connard" V1
; Creative Commons BY-NC-SA 2013 - furrtek.org

VBL_gamecamp:
  call   fadefromwhite

  call   RAMtoOAM

  ei                            ;Allow the RLI to be triggered before the RETN

  ld     a,(PAUSE_FLAG)
  or     a
  jr     nz,+++
  
  call   gc_inc_score
  
  call   check_zero_lives

  ; Make last life blink
  ld     a,(LIVES)
  cp     1
  jr     nz,+
  ld     c,GC_T_BLANK
  ld     a,(VBLC)
  and    $10
  jr     nz,++
  call   clear_lives
  jr     +
++:
  ld     a,GC_T_LIFE		;Life tile
  call   update_lives
+:

  call   gc_update_sprites
  
  ld     hl,OAMCOPY
  ld     bc,$A0
  call   clear

  ld     b,$A0+14
  ld     hl,TIME_SEC
  ld     e,(hl)
  inc    hl
  ld     d,(hl)
  ld     hl,$9800+64+10
  call   disp_time
  call   gc_render_sprites

  call   inc_time
  
  call   dec_invinc

+++:
  call   readinput
  call   gc_input

  call   stepmusic		;For the pause jingle/train sound

  ld     hl,VBLC
  inc    (hl)

  ret
