; This file is part of the source code for "Super Connard" V1
; Creative Commons BY-NC-SA 2013 - furrtek.org

disp_serial:
  di
  call   wait_vbl
  ld     a,%00010001            ;Turn off screen
  ldh    ($40),a

  ld     hl,$8000               ;White tile
  ld     bc,$10
  call   clear
  
  ld     de,$8000+(1*16)
  call   load_bignumbers

  call   clearbkg
  call   clearsprites

  xor    a
  ldh    ($42),a                ;Scroll Y
  ldh    ($43),a                ;Scroll X

  ld     a,%11100100            ;BG palette
  ldh    ($47),a

  ld	 a,(serial_ptr)
  ld     d,a
  ld	 a,(serial_ptr+1)
  ld     e,a

  ld     hl,$9900-32+6
  ld     c,1
  call   disp_DE_big

  ld     a,%10010001            ;Turn on screen, BG on, sprites ON 8x16, window ON, tiles at $8000
  ldh    ($40),a

-:
  call   readinput
  and    $0F
  jr     z,-

  call   Setup_logo
  ret
