; This file is part of the source code for "Super Connard" V1
; Creative Commons BY-NC-SA 2013 - furrtek.org

playsfx:
  push   af
  push   de
  ldi    a,(hl)
  push   hl
  ld     d,0
  sla    a              ;*2 (words)
  ld     e,a
  ld     hl,sfxstartreg
  add    hl,de
  ldi    a,(hl)
  ld     d,(hl)
  ld     e,a             ;DE=(sfxstartreg+A*2)
  pop    hl
-:
  ld     a,(hl)
  or     a
  jr     z,+
  ld     (de),a
  inc    de
  inc    hl
  jr     -
+:
  dec    hl
  dec    de
  ld     a,(hl)
  set    7,a
  ld     (de),a
  pop    de
  pop    af
  ret
  
sfxstartreg:
.dw $FF10,$FF16,$FF1A,$FF20

startsfx:
  ld     a,(Sot_Flags)	;Kill "music", prevents sound disable after pause switching too fast
  and    255~Sot_F_Play
  ld     (Sot_Flags),a
  ld     a,%10000000    ;APU active
  ldh    ($26),a
  ld     a,%01110111    ;Max volume on L and R
  ldh    ($24),a
  ld     a,%11111111    ;All channels on L and R
  ldh    ($25),a
  ret
  
fxscore:
.db 1
.db %01111101
.db %10000001
.db %10100000
.db %11111111
.db 0

fxground:
.db 3
.db %11111111
.db %11110001
.db %01111010
.db %10111111
.db 0
  
fx_grabmiss:
.db 0
.db %10100010   ; Grab miss
.db %10111111
.db %11001111
.db %11111000
.db %10111010
.db 0

fx_grabok:
.db 0
.db %10010100   ; Grab !
.db %10111111
.db %11111111
.db %11111000
.db %10111010
.db 0

fx_grabpoison:
.db 0
.db %11011100
.db %10000000
.db %11111111
.db %11000000
.db %11111010
.db 0

fx_drift:
.db 3
.db %11110000
.db %10000010
.db %01110001
.db %10111111
.db 0

fx_hit:
.db 0
.db %10101011
.db %01111111
.db %11110010
.db %00000001	; Lol that stupid bug, can't put 0 because it's the end of list code... Will change that.
.db %10111111
.db 0

fx_val:
.db 0
.db $C4
.db $70
.db $F1
.db $FF
.db $BD
.db 0

fx_err:
.db 0
.db $C4
.db $70
.db $F1
.db $FF
.db $B8
.db 0

fx_track:
.db 3
.db $FF
.db $F1
.db $69
.db $BF
.db 0
