;hl=data
;de=vram
loadtiles_2BPPc:
  inc    hl
;BP0
  push   de
  call   decompress
  pop    de
  inc    de
;BP1
  call   decompress
  ret

decompress:
  ldi    a,(hl)
  or     a
  ret    z
  bit    7,a            ;bit7=1:compressed
  jr     nz,compressed
  and    $7F            ;bit7=0:normal
  ld     b,a
loadnormal:
-:
  ldh    a,($41)        ;mode vram ok ?
  and    3
  cp     2
  jr     nc,-
  ldi    a,(hl)
  ld     (de),a
  inc    de             ;sauter un bitplane (charge plus tard)
  inc    de
  dec    b
  jr     nz,loadnormal
  jr     decompress
compressed:
  and    $7F
  ld     b,a
  ldi    a,(hl)
loadcompressed:
  push   af
-:
  ldh    a,($41)        ;mode vram ok ?
  and    3
  cp     2
  jr     nc,-
  pop    af
  ld     (de),a
  inc    de             ;sauter un bitplane (charge plus tard)
  inc    de
  dec    b
  jr     nz,loadcompressed
  jr     decompress
