; This file is part of the source code for "Super Connard" V1
; Creative Commons BY-NC-SA 2013 - furrtek.org

Setup_logo:
  di

  call   screen_off

  ld     a,%11100100            ;Bg palette
  ldh    ($47),a

  ld     hl,(:tiles_fse*$4000)+tiles_fse
  ld     de,$8010
  call   loadtiles_auto

  call   clearbkg
  call   clearsprites

  ;map le logo FSE
  ld     bc,$0803
  ld     a,1
  ld     hl,$9800+(32*8)+6
  call   mapinc

  xor    a
  ldh    ($42),a                ;Scroll Y
  ldh    ($43),a                ;Scroll X

  ld     a,%11111111            ;Palette BG, tout en blanc
  ldh    ($47),a

  ld     a,%10010001            ;Turn screen on, BG on, sprites OFF, window OFF, tiles at $8000
  ldh    ($40),a

  ld     a,%00010000            ;Vblank
  ldh    ($41),a
  ld     a,%00000001
  ldh    ($FF),a

  xor    a
  ld     (FADEIDX),a
  ld     (VBLC),a

  ld     hl,VBL_HANDLER
  ld     de,VBL_logo
  ld     (hl),e
  inc    hl
  ld     (hl),d

  ld     de,RLI_null
  call   load_RLI
  
  ei

  ret


VBL_logo:
  call   fadefromwhite
  call   readinput
  and    $0F
  jr     z,fwait
  jr	 totitle
fwait:
  ld     a,(VBLC)
  inc    a
  cp     $80            ;~2 seconds
  jr     nz,cwait
totitle:
  ld     de,Setup_intro
  call   Setup_exit_black
  ret
cwait:
  ld     (VBLC),a
  ret
