; This file is part of the source code for "Super Connard" V1
; Creative Commons BY-NC-SA 2013 - furrtek.org

; Instrument parameters tables done by hand, too lazy to finish GUI editor

instruments:
  .dw instru1        ;Square PWM 1 CH1
  .dw instru2        ;Square PWM 2 CH1
  .dw instru3        ;Square PWM 3 CH1
  .dw instru4        ;Square PWM 4 CH1
  .dw instru5        ;Square PWM 1 CH2
  .dw instru6        ;Square PWM 2 CH2
  .dw instru7        ;Square PWM 3 CH2
  .dw instru8        ;Square PWM 4 CH2 sustain
  .dw instru9        ;Kick
  .dw instru10       ;Snare
  .dw instru11       ;Hat
  .dw instru12       ;Wave
  .dw instru12       ;Wave

instru1:
  .db 0
  .db $80
  .db $1F
  .db $87
  .db $BF

instru2:
  .db 0
  .db $80
  .db $5F
  .db $B1
  .db $BF

instru3:
  .db 0
  .db $80
  .db $9F
  .db $B1
  .db $BF

instru4:
  .db 0
  .db $80
  .db $DF
  .db $B1
  .db $BF

instru5:
  .db 1
  .db $1F
  .db $83
  .db $BF

instru6:
  .db 1
  .db $5F
  .db $83
  .db $BF

instru7:
  .db 1
  .db $9F
  .db $83
  .db $BF

instru8:	;CH2
  .db 1
  .db $D1	;DF
  .db $F7	;87 envelope length+sweep time
  .db $BF

instru9:
  .db 3
  .db $FF
  .db $B1
  .db $80
  .db $BF

instru10:
  .db 3
  .db $FF
  .db $81
  .db $51
  .db $BF

instru11:
  .db 3
  .db $FF
  .db $81
  .db $31
  .db $BF

instru12:
  .db 2
  .db $80
  .db $00
  .db %01000000
  .db $BF
  .db $FF
  .db $EE
  .db $DD
  .db $CC
  .db $BB
  .db $AA
  .db $99
  .db $88
  .db $77
  .db $66
  .db $55
  .db $44
  .db $33
  .db $22
  .db $11
  .db $00
