; This file is part of the source code for "Super Connard" V1
; Creative Commons BY-NC-SA 2013 - furrtek.org

update_scroller:
  ld     a,(BKG_Y)              ;Update text every 8 lines (1 tile)
  and    7
  jr     nz,++

  ld     de,text_clear
  ld     a,(Scroll_MapPtr)      ;HL=text_clear
  ld     h,a
  ld     a,(Scroll_MapPtr+1)
  ld     l,a
  push   hl
  ld     b,32
  call   maptext                ;Clear line (save MAPPTR)
  ld     hl,Scroll_TxtPtr       ;DE=(CREDITS_TXTPTR)
  ld     d,(hl)
  inc    hl
  ld     e,(hl)
  pop    hl
  call   maptext                ;Write line
  push   de
  ld     de,32
  add    hl,de                  ;Advances one line (32 tiles) and wrap $9C00 to $98
  ld     a,h
  cp     $9C
  jr     nz,+
  ld     a,$98
+:
  ld     h,a
  push   hl
  pop    de
  ld     hl,Scroll_MapPtr       ;CREDITS_MAPPTR = following line
  ld     (hl),d
  inc    hl
  ld     (hl),e
  pop    de
  inc    de
  ld     a,(de)
  or     a
  jr     nz,+
  ld     hl,Scroll_JumpTo	;End of text
  ldi    a,(hl)
  ld     l,(hl)
  ld     h,a
  call   dojump
  ret
+:
  ld     hl,Scroll_TxtPtr       ;CREDITS_TXTPTR = following line
  ld     (hl),d
  inc    hl
  ld     (hl),e
++:
  
  ld     a,(BKG_Y)
  ldh    ($42),a                ;Scroll Y
  inc    a
  ld     (BKG_Y),a
  ret
