drawVUs:

  ld     a,(VU1)
  or     a
  jr     z,+
  dec    a
  dec    a
+:
  ld     (VU1),a

  ld     hl,$9800+32*6+2
  call   drawbar

  ld     a,(VU2)
  or     a
  jr     z,+
  dec    a
  dec    a
+:
  ld     (VU2),a

  ld     hl,$9800+32*8+2
  call   drawbar

  ld     a,(VU3)
  or     a
  jr     z,+
  dec    a
  dec    a
+:
  ld     (VU3),a

  ld     hl,$9800+32*10+2
  call   drawbar

  ld     a,(VU4)
  or     a
  jr     z,+
  dec    a
  dec    a
+:
  ld     (VU4),a

  ld     hl,$9800+32*12+2
  call   drawbar

  ld     b,$4F
-:
  dec    b
  jr     nz,-

  ret




drawbar:
  call   wait_write
  ld    (hl),$74
  inc   hl
  ld     c,16
-:
  sub    8
  jr     nc,+
  xor    $FF
  ld     b,$76
  add    b
  call   wait_write
  ldi    (hl),a
  jr     ++
+:
  call   wait_write
  ld     (hl),$75
  inc    hl
  dec    c
  jr     -
++:
  ld     a,c
  or     a
  ret    z
  xor    a
-:
  call   wait_write
  ldi    (hl),a
  dec    c
  jr     nz,-
  ret
  
wait_write:
  push   af
-:
  ldh    a,($41)
  and    3
  cp     2
  jr     nc,-
  pop    af
  ret
  
